class Link < ActiveRecord::Base
  has_many :assorts
  has_many :tags, :through=>:assorts
  belongs_to :user

  def tag_names=(value)
    Tag.transaction do
      self.save
      tag_ids = self.tags.map(&:id)
      self.tags.delete(Tag.find(tag_ids)) if self.tags
      tags = value.split(" ")
      tags.each do |t|
        self.tags << Tag.find_or_create_by_name(t)
      end
    end
  end

  def tag_names
    self.tags.map(&:name).join(" ")
  end

  def self.create_with_user(condition, current_user)
    @link = Link.create(condition) 
    @link.user = current_user    
    @link
  end

  def self.find_by_user_name_and_tag_id(user_name, tag_id)
    Link.find_by_sql([<<-SQL, {:user_name => user_name, :tag_id => tag_id}])
      SELECT 
        links.*
      FROM
        users,
        tags,
        assorts,
        links
      WHERE
        users.login = :user_name
      AND
        links.user_id = users.id
      AND
        assorts.link_id = links.id
      AND
        tags.id = :tag_id
      AND
        tags.id = assorts.tag_id
    SQL
  end
end
